#!/usr/local/bin/perl5 -w

# Copyright (c) 1999 Gabriel Deal. All rights reserved.
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.


use lib '../lib';
use CGI qw(start_table end_table);
use strict;
use Rball;
use Globals;

######################

my $g_page_name = 'UWIRL Rankings';

my $dummy;
$dummy = $Globals::num_ladders;
$dummy = $Globals::ladder_names;

my $c = new CGI;
my $rball = new Rball "r";
#my $rball = new Rball;

$| = 1;
print $c->header
	. $c->start_html({-Title => $g_page_name});

my $header = "";
foreach my $col ($rball->get_user_order())
{
	$header .= $c->th($col);
}

my($text, $word);

my @columns = qw(
	rank
	email
	name
	affiliation
	department
	wins
	losses
	forfeit
	phone
);

foreach(1 .. $Globals::num_ladders)
{
	print	 $c->h1($Globals::ladder_names[$_ - 1])
		 . $c->start_table({Border => 1});
	$text = "";
	foreach $word (@columns)
	{
		if($word eq "forfeit")
		{
			$text .= $c->th(
				"forfeits"
				. $c->sup("<A Href='#forfeits'>*</A>")
				);
		}
		else
		{
			$text .= $c->th($word);
		}
	}
	print $c->Tr($text);
	&print_ladder($c, $_, $rball, @columns);
	print $c->end_table();
}

print $c->end_table();

print $c->p
	. $c->sup("* ")
	. $c->a({-Name => 'forfeits'})
	. $c->strong("About forfeits:  ")
	. "The forfeit column is set to zero whenever a player actually plays a match, so it would be better labeled \"consecutive forfeits\" or \"forfeits in a row\".   A forfeit also counts as a loss and is counted in the losses column."; 
print "$Globals::footer";
print $c->end_html;

	
exit 0;

#######################


sub print_ladder
{
	my $c = shift;
	my $ladder = shift;
	my $rball = shift;
	my @columns = @_;
	
	my $text = "";
	my($value, $url);
	foreach my $row_ref ($rball->get_ladder($ladder))
	{
		$text = "";
		$url = $row_ref->{url};
		$url = undef if ! defined $url or $url =~ /^\s*$/;
		foreach my $col (@columns)
		{
			$value = $row_ref->{$col};
			if($col eq "email")
			{
				$text .= $c->td(qq!<A Href="mailto:$value">$value</A>!);
			}
			elsif($col eq "name")
			{
				$text .= $c->td(qq!<A Href="$url">$value</A>!) if defined $url;
				$text .= $c->td($value) if ! defined $url;
			}
			else
			{
				$text .= $c->td("$value&nbsp;");
			}
		}
	 	print $c->Tr($text);
	}
}
